<template>
  <div
    :class="[
      'messaging-message-list-item-other',
      { 'messaging-message-list-item-other--continues': message.continues },
    ]"
  >
    <div class="messaging-message-list-item-other__avatar">
      <router-link :to="route" v-if="!message.continues">
        <UserAvatar :user="otherUser" :route="route" size="md" />
      </router-link>
    </div>
    <div class="messaging-message-list-item-other__main">
      <div
        class="messaging-message-list-item-other__bubble"
        data-bs-toggle="tooltip"
        :title="moment(message.created).format('llll')"
      >
        <span v-html="formattedBody" />
      </div>
    </div>
  </div>
</template>

<script>
import { computed } from 'vue'
import { useStore } from 'vuex'
import { UserAvatar } from '../../gallery'
import { useMessageListItem } from './message-list-item.js'

export default {
  name: 'MessagingMessageListItemOther',
  components: {
    UserAvatar,
  },
  props: {
    message: { type: Object, required: true },
  },
  setup(props) {
    const baseProperties = useMessageListItem(props)

    const store = useStore()

    const route = computed(() => {
      return otherUser.value ? { name: 'identity-user-profile', params: { username: otherUser.value.username } } : null
    })

    const otherUser = computed(() => {
      return store.state.identity.session.userId === props.message.fromUserId
        ? props.message.toUser
        : props.message.fromUser
    })

    return {
      ...baseProperties,
      route,
      otherUser,
    }
  },
}
</script>

<style lang="scss">
@use '../../core/sass/vars';

.messaging-message-list-item-other {
  display: flex;
  margin-bottom: vars.$spacing;
}

.messaging-message-list-item-other--continues {
  margin-bottom: calc(vars.$spacing / 4);
}

.messaging-message-list-item-other__avatar {
  flex: 64px 0 0;
  margin-right: vars.$spacing;
}

/* Fake (pseudo) element, that enables vertical-align */
.messaging-message-list-item-other__avatar:before {
  content: '';
  display: inline-block;
  vertical-align: bottom;
  height: 100%;
}

.messaging-message-list-item-other__main {
  flex: auto 1 1;
  min-width: 0; // Stops the text from overflowing
}

.messaging-message-list-item-other__bubble {
  word-wrap: break-word;
  position: relative;
  padding: vars.$spacing;
  border-radius: 1rem;
  background-color: vars.$panelColor;
  color: vars.$subtextColor;
  width: 80%;
  margin-right: auto;

  p:last-of-type {
    margin-bottom: 0;
  }
}

.dark .messaging-message-list-item-other__bubble {
  background-color: vars.$darkPanelColor;
  color: vars.$darkSubtextColor;
}
</style>
